Subject: bug#58790: Eglot URI parsing bug when using clojure-lsp server

From: Michael Albinus <[email-masked]>
Date: Sat, 10 Dec 2022 18:45:20 +0100

Danny Freeman <[email-masked]> writes:

Hi Danny,

> Thanks for taking the time to explain more. I understand now, and have
> enough information to re-create this scenario myself. Once I do that
> I'll see how I can account for this scenario in jarchive. When I do I
> will post an update.

Just some random thoughts. In jarchive, I believe you have two options:

- Use tramp-archive. This is restricted to local GNU/Linux systems(*),
  but it shall work out of the box. If you have a local jar archive,
  just map the file name to something like

  jar:file:///home/albinus/.m2/repository/org/clojure/clojure/1.10.3/clojure-1.10.3.jar!/clojure/core.clj
  => /home/albinus/.m2/repository/org/clojure/clojure/1.10.3/clojure-1.10.3.jar/clojure/core.clj

  Try it out, it will work out of the box :-)

  If the jar archive is located on a remote host, say /ssh:user@host:,
  just prepend that remote file name location:

  /ssh:user@host:/home/albinus/.m2/repository/org/clojure/clojure/1.10.3/clojure-1.10.3.jar/clojure/core.clj

  Try it out, it will work out of the box :-)

- Use jarchive as it is, but on a local cop< if it is located on a
  remote host. If the jarchive is located on, /ssh:user@host:, copy it
  locally:

  (copy-file "/ssh:user@host:/home/albinus/.m2/repository/org/clojure/clojure/1.10.3/clojure-1.10.3.jar"
            "/tmp/home_albinus_.m2_repository_org_clojure_clojure_1.10.3_clojure-1.10.3.jar"

  Let your jarchive file name handler run on this temp file /tmp/home_albinus_.m2_repository_org_clojure_clojure_1.10.3_clojure-1.10.3.jar!/clojure/core.clj

(*): There are plans to integrate libarchive(3) natively into Emacs. Then
     this would work on all systems.

Best regards, Michael.